// Auto_HomeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Auto_Home.h"
#include "Auto_HomeDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAuto_HomeDlg dialog

CAuto_HomeDlg::CAuto_HomeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAuto_HomeDlg::IDD, pParent)
	, m_dwAcce(200000)
	, m_dwHomeSpeed(800)
	, m_dwStartSpeed(1000)
	, m_dwDriveSpeed(500000)
	, m_dwDecel(200000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, m_ErrorOccure(0x00)
	, m_StopMonitor(0x00)
	, m_wAxis(0)
	, nTimer(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAuto_HomeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_HOME_STEP4, m_cbHomeStep4);
	DDX_Control(pDX, IDC_COMBO_HOME_STEP3, m_cbHomeStep3);
	DDX_Control(pDX, IDC_COMBO_HOME_STEP2, m_cbHomeStep2);
	DDX_Control(pDX, IDC_COMBO_HOME_STEP1, m_cbHomeStep1);
	DDX_Text(pDX, IDC_EDIT_A, m_dwAcce);
	DDX_Text(pDX, IDC_EDIT_SV, m_dwStartSpeed);
	DDX_Text(pDX, IDC_EDIT_HV, m_dwHomeSpeed);
	DDX_Text(pDX, IDC_EDIT_V, m_dwDriveSpeed);
	DDX_Text(pDX, IDC_EDIT_D, m_dwDecel);
}

BEGIN_MESSAGE_MAP(CAuto_HomeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BT_START, &CAuto_HomeDlg::OnStartHome)
	ON_BN_CLICKED(IDC_BT_STOP, &CAuto_HomeDlg::OnTerminateHome)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CAuto_HomeDlg message handlers

BOOL CAuto_HomeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	m_cbHomeStep1.SetCurSel( 1 ); // AUTO_HOME_STEP1_FORWARD
	m_cbHomeStep2.SetCurSel( 2 ); // AUTO_HOME_STEP2_REVERSE
	m_cbHomeStep3.SetCurSel( 0 ); // AUTO_HOME_STEP3_DISABLE
	m_cbHomeStep4.SetCurSel( 0 ); // AUTO_HOME_STEP4_DISABLE
	
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_cmdcounter(m_CurSlotNo, AXIS_X, 0)) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_cmdcounter() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enccounter(m_CurSlotNo, AXIS_X, 0)) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enccounter() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

Initial_Error:
				if( nErrCode == SUCCESS_NO_ERROR )
					nTimer = SetTimer( 1, 100, NULL );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}		
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CAuto_HomeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_AUTO_HOME_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_AUTO_HOME_DIALOG));
	}
}
#endif


void CAuto_HomeDlg::OnStartHome()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
	int nIndex;
	WORD wHomeStep1, wHomeStep2, wHomeStep3, wHomeStep4, wHomeSteps;


	UpdateData(TRUE);

	nIndex = m_cbHomeStep1.GetCurSel();
	switch( nIndex )
	{
	case 0:
		wHomeStep1 = AUTO_HOME_STEP1_DISABLE;
		break;
	case 1:
		wHomeStep1 = AUTO_HOME_STEP1_FORWARD;
		break;
	case 2:
		wHomeStep1 = AUTO_HOME_STEP1_REVERSE;
		break;
	default:
		wHomeStep1 = AUTO_HOME_STEP1_DISABLE;
		break;
	}


	nIndex = m_cbHomeStep2.GetCurSel();
	switch( nIndex )
	{
	case 0:
		wHomeStep2 = AUTO_HOME_STEP2_DISABLE;
		break;
	case 1:
		wHomeStep2 = AUTO_HOME_STEP2_FORWARD;
		break;
	case 2:
		wHomeStep2 = AUTO_HOME_STEP2_REVERSE;
		break;
	default:
		wHomeStep2 = AUTO_HOME_STEP2_DISABLE;
		break;
	}

	nIndex = m_cbHomeStep3.GetCurSel();
	switch( nIndex )
	{
	case 0:
		wHomeStep3 = AUTO_HOME_STEP3_DISABLE;
		break;
	case 1:
		wHomeStep3 = AUTO_HOME_STEP3_FORWARD;
		break;
	case 2:
		wHomeStep3 = AUTO_HOME_STEP3_REVERSE;
		break;
	default:
		wHomeStep3 = AUTO_HOME_STEP3_DISABLE;
		break;
	}

	nIndex = m_cbHomeStep4.GetCurSel();
	switch( nIndex )
	{
	case 0:
		wHomeStep4 = AUTO_HOME_STEP4_DISABLE;
		break;
	case 1:
		wHomeStep4 = AUTO_HOME_STEP4_FORWARD;
		break;
	case 2:
		wHomeStep4 = AUTO_HOME_STEP4_REVERSE;
		break;
	default:
		wHomeStep4 = AUTO_HOME_STEP4_DISABLE;
		break;
	}

	wHomeSteps = (wHomeStep1 | wHomeStep2 | wHomeStep3 | wHomeStep4);

	if( (nErrCode = i8094_set_home_cfg( m_CurSlotNo, AXIS_X, HOME_LOGIC_ACTIVE_LOW,\
		NHOME_LOGIC_ACTIVE_LOW, INDEX_LOGIC_ACTIVE_LOW, wHomeSteps, 0x00 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_set_home_cfg() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}
	else
	{
		if( (nErrCode = i8094_home_start( m_CurSlotNo, AXIS_X, m_dwStartSpeed, m_dwAcce, m_dwDecel, m_dwDriveSpeed, m_dwHomeSpeed, DISABLE_BLOCK_OPEARTION )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_home_start() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}	
}

void CAuto_HomeDlg::OnTerminateHome()
{
	// TODO: Add your control notification handler code here
	BYTE bDone;
	WORD wStopStatus;
	short nErrCode;
	CString strErrMsg;

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_motion_done() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( bDone != MOTION_DONE )
	{
		if( (nErrCode = i8094_stop_move( m_CurSlotNo, AXIS_X, STOP_SUDDEN )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_stop_move() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}
	else
	{
		TRACE( TEXT(" Motion Done! Finish Status [0x%04X]\n"), wStopStatus );
	}
}

void CAuto_HomeDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}	
}

void CAuto_HomeDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter, nEncPosition;
	DWORD dwCurSpeed, dwCurAcceleration;
	short nErrCode;
	CString strTmp;

	if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}		

		if( (nErrCode = i8094_get_enccounter( m_CurSlotNo, AXIS_X, &nEncPosition )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_enccounter() failed, error code = %d\n"), nErrCode );
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed() failed, error code = %d\n"), nErrCode );
		}

		if( (nErrCode = i8094_get_acc( m_CurSlotNo, AXIS_X, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc() failed, error code = %d\n"), nErrCode );
		}

		strTmp.Format( TEXT("%d"), nCmdCounter );
		SetDlgItemText( IDC_STATIC_LP, strTmp );

		strTmp.Format( TEXT("%d"), nEncPosition );
		SetDlgItemText( IDC_STATIC_EP, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeed );
		SetDlgItemText( IDC_STATIC_CV, strTmp );

		strTmp.Format( TEXT("%d"), dwCurAcceleration );
		SetDlgItemText( IDC_STATIC_CA, strTmp );
	}

	CDialog::OnTimer(nIDEvent);
}
