// DI_StatusDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DI_Status.h"
#include "DI_StatusDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define wTarget_Axis		AXIS_X

// CDI_StatusDlg dialog

CDI_StatusDlg::CDI_StatusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDI_StatusDlg::IDD, pParent)
	, m_INP_En(0)
	, m_Alarm_En(0)
	, m_Polarity_ELP(0)
	, m_Polarity_INP(0)
	, m_Polarity_Alarm(0)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDI_StatusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ICON_INP_OFF, m_INP_OFF);
	DDX_Control(pDX, IDC_ICON_IN3_OFF, m_IN3_OFF);
	DDX_Control(pDX, IDC_ICON_NHOME_OFF, m_NORG_OFF);
	DDX_Control(pDX, IDC_ICON_HOME_OFF, m_ORG_OFF);
	DDX_Control(pDX, IDC_ICON_ALM_OFF, m_ALM_OFF);
	DDX_Control(pDX, IDC_ICON_EMG_OFF, m_EMG_OFF);
	DDX_Control(pDX, IDC_ICON_LMTM_OFF, m_LMTM_OFF);
	DDX_Control(pDX, IDC_ICON_LMTP_OFF, m_LMTP_OFF);
	DDX_Control(pDX, IDC_ICON_INP_ON, m_INP_ON);
	DDX_Control(pDX, IDC_ICON_IN3_ON, m_IN3_ON);
	DDX_Control(pDX, IDC_ICON_NHOME_ON, m_NORG_ON);
	DDX_Control(pDX, IDC_ICON_HOME_ON, m_ORG_ON);
	DDX_Control(pDX, IDC_ICON_ALM_ON, m_ALM_ON);
	DDX_Control(pDX, IDC_ICON_EMG_ON, m_EMG_ON);
	DDX_Control(pDX, IDC_ICON_LMTM_ON, m_LMTM_ON);
	DDX_Control(pDX, IDC_ICON_LMTP_ON, m_LMTP_ON);
}

BEGIN_MESSAGE_MAP(CDI_StatusDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_Alarm_Enable, &CDI_StatusDlg::OnAlarmEnable)
	ON_BN_CLICKED(IDC_RADIO_Alarm_Disable, &CDI_StatusDlg::OnAlarmDisable)
	ON_BN_CLICKED(IDC_RADIO_INP_Enable, &CDI_StatusDlg::OnINPEnable)
	ON_BN_CLICKED(IDC_RADIO_INP_Disable, &CDI_StatusDlg::OnINPDisable)
	ON_BN_CLICKED(IDC_RADIO_INP_HIGH, &CDI_StatusDlg::OnRadioInpHigh)
	ON_BN_CLICKED(IDC_RADIO_INP_LOW, &CDI_StatusDlg::OnRadioInpLow)
	ON_BN_CLICKED(IDC_RADIO_EL_HIGH, &CDI_StatusDlg::OnRadioElHigh)
	ON_BN_CLICKED(IDC_RADIO_EL_LOW, &CDI_StatusDlg::OnRadioElLow)
	ON_BN_CLICKED(IDC_RADIO_ALARM_HIGH, &CDI_StatusDlg::OnRadioAlarmHigh)
	ON_BN_CLICKED(IDC_RADIO_ALARM_LOW, &CDI_StatusDlg::OnRadioAlarmLow)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CDI_StatusDlg message handlers

BOOL CDI_StatusDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	m_LMTP_ON.ShowWindow( FALSE ); 
	m_LMTP_OFF.ShowWindow( TRUE ); 

	m_LMTM_ON.ShowWindow( FALSE ); 
	m_LMTM_OFF.ShowWindow( TRUE ); 

	m_EMG_ON.ShowWindow( FALSE ); 
	m_EMG_OFF.ShowWindow( TRUE ); 

	m_ALM_ON.ShowWindow( FALSE ); 
	m_ALM_OFF.ShowWindow( TRUE ); 

	m_ORG_ON.ShowWindow( FALSE ); 
	m_ORG_OFF.ShowWindow( TRUE ); 

	m_NORG_ON.ShowWindow( FALSE ); 
	m_NORG_OFF.ShowWindow( TRUE ); 

	m_INP_ON.ShowWindow( FALSE ); 
	m_INP_OFF.ShowWindow( TRUE ); 

	m_IN3_ON.ShowWindow( FALSE ); 
	m_IN3_OFF.ShowWindow( TRUE );

	((CButton*) GetDlgItem(IDC_RADIO_Alarm_Disable))->SetCheck( BST_CHECKED );
	((CButton*) GetDlgItem(IDC_RADIO_INP_Disable))->SetCheck( BST_CHECKED );

	((CButton*) GetDlgItem(IDC_RADIO_ALARM_LOW))->SetCheck( BST_CHECKED );
	((CButton*) GetDlgItem(IDC_RADIO_INP_LOW))->SetCheck( BST_CHECKED );
	((CButton*) GetDlgItem(IDC_RADIO_EL_LOW))->SetCheck( BST_CHECKED );



	// TODO: Add extra initialization here
	
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;
				i8094_set_inp( m_CurSlotNo, wTarget_Axis, INP_DISABLE_FEATURE, INP_LOGIC_ACTIVE_LOW );
				i8094_set_alarm( m_CurSlotNo, wTarget_Axis, ALARM_DISABLE_FEATURE, ALARM_LOGIC_ACTIVE_LOW );


				nTimer = SetTimer( 1, 200, NULL );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}		

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CDI_StatusDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_DI_STATUS_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_DI_STATUS_DIALOG));
	}
}
#endif


void CDI_StatusDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}
}

void CDI_StatusDlg::OnAlarmEnable()
{
	// TODO: Add your control notification handler code here
	m_Alarm_En = 1;

	if( m_Polarity_Alarm == 0 ) // Active Low
		i8094_set_alarm( m_CurSlotNo, wTarget_Axis, ALARM_ENABLE_FEATURE, ALARM_LOGIC_ACTIVE_LOW );
	else
		i8094_set_alarm( m_CurSlotNo, wTarget_Axis, ALARM_ENABLE_FEATURE, ALARM_LOGIC_ACTIVE_HIGH );

	GetDlgItem( IDC_RADIO_ALARM_LOW )->EnableWindow( TRUE );
	GetDlgItem( IDC_RADIO_ALARM_HIGH )->EnableWindow( TRUE );


}

void CDI_StatusDlg::OnAlarmDisable()
{
	// TODO: Add your control notification handler code here
	i8094_set_alarm( m_CurSlotNo, wTarget_Axis, ALARM_DISABLE_FEATURE, ALARM_LOGIC_ACTIVE_LOW );
	m_Alarm_En = 0;

	GetDlgItem( IDC_RADIO_ALARM_LOW )->EnableWindow( FALSE );
	GetDlgItem( IDC_RADIO_ALARM_HIGH )->EnableWindow( FALSE );

}

void CDI_StatusDlg::OnINPEnable()
{
	// TODO: Add your control notification handler code here
	m_INP_En = 1;

	if( m_Polarity_INP == 0 ) // Active Low
		i8094_set_inp( m_CurSlotNo, wTarget_Axis, INP_ENABLE_FEATURE, INP_LOGIC_ACTIVE_LOW );
	else
		i8094_set_inp( m_CurSlotNo, wTarget_Axis, INP_ENABLE_FEATURE, INP_LOGIC_ACTIVE_HIGH );

	GetDlgItem( IDC_RADIO_INP_LOW )->EnableWindow( TRUE );
	GetDlgItem( IDC_RADIO_INP_HIGH )->EnableWindow( TRUE );


}

void CDI_StatusDlg::OnINPDisable()
{
	// TODO: Add your control notification handler code here
	i8094_set_inp( m_CurSlotNo, wTarget_Axis, INP_DISABLE_FEATURE, INP_LOGIC_ACTIVE_LOW );
	m_INP_En = 0;

	GetDlgItem( IDC_RADIO_INP_LOW )->EnableWindow( FALSE );
	GetDlgItem( IDC_RADIO_INP_HIGH )->EnableWindow( FALSE );

}

void CDI_StatusDlg::OnRadioInpHigh()
{
	// TODO: Add your control notification handler code here
	i8094_set_inp( m_CurSlotNo, wTarget_Axis, INP_ENABLE_FEATURE, INP_LOGIC_ACTIVE_HIGH );

}

void CDI_StatusDlg::OnRadioInpLow()
{
	// TODO: Add your control notification handler code here
	i8094_set_inp( m_CurSlotNo, wTarget_Axis, INP_ENABLE_FEATURE, INP_LOGIC_ACTIVE_LOW );

}

void CDI_StatusDlg::OnRadioElHigh()
{
	// TODO: Add your control notification handler code here
	i8094_set_limit( m_CurSlotNo, wTarget_Axis, LIMIT_LOGIC_ACTIVE_HIGH ); 	
}

void CDI_StatusDlg::OnRadioElLow()
{
	// TODO: Add your control notification handler code here
	i8094_set_limit( m_CurSlotNo, wTarget_Axis, LIMIT_LOGIC_ACTIVE_LOW ); 	
}

void CDI_StatusDlg::OnRadioAlarmHigh()
{
	// TODO: Add your control notification handler code here
	i8094_set_alarm( m_CurSlotNo, wTarget_Axis, ALARM_ENABLE_FEATURE, ALARM_LOGIC_ACTIVE_HIGH );
}

void CDI_StatusDlg::OnRadioAlarmLow()
{
	// TODO: Add your control notification handler code here
	i8094_set_alarm( m_CurSlotNo, wTarget_Axis, ALARM_ENABLE_FEATURE, ALARM_LOGIC_ACTIVE_LOW );	

}

void CDI_StatusDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	WORD wActiveSts;
	BYTE bIN3Sts;
	short retErr;
	CString strMsg;
	
	retErr = i8094_get_mdi_status( m_CurSlotNo, wTarget_Axis, &wActiveSts );
	retErr = i8094_get_in3( m_CurSlotNo, wTarget_Axis, &bIN3Sts );


	if( retErr == SUCCESS_NO_ERROR )
	{
		strMsg.Format( TEXT("Active IO Status: 0x%04X"), wActiveSts );
		SetDlgItemText( IDC_STATIC_ACTIVE_IO, strMsg );

		if( (wActiveSts & DI_STATUS_ACTIVE_LMTP ) == DI_STATUS_ACTIVE_LMTP )
		{
			m_LMTP_ON.ShowWindow( TRUE ); 
			m_LMTP_OFF.ShowWindow( FALSE ); 
		}
		else
		{
			m_LMTP_ON.ShowWindow( FALSE ); 
			m_LMTP_OFF.ShowWindow( TRUE ); 
		}

		if( (wActiveSts & DI_STATUS_ACTIVE_LMTM ) == DI_STATUS_ACTIVE_LMTM )
		{
			m_LMTM_ON.ShowWindow( TRUE );
			m_LMTM_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_LMTM_ON.ShowWindow( FALSE ); 
			m_LMTM_OFF.ShowWindow( TRUE ); 
		}


		if( (wActiveSts & DI_STATUS_ACTIVE_EMG ) == DI_STATUS_ACTIVE_EMG )
		{
			m_EMG_ON.ShowWindow( TRUE );
			m_EMG_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_EMG_ON.ShowWindow( FALSE ); 
			m_EMG_OFF.ShowWindow( TRUE ); 
		}


		if( (wActiveSts & DI_STATUS_ACTIVE_ALARM ) == DI_STATUS_ACTIVE_ALARM )
		{
			m_ALM_ON.ShowWindow( TRUE );
			m_ALM_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_ALM_ON.ShowWindow( FALSE ); 
			m_ALM_OFF.ShowWindow( TRUE ); 
		}

		if( (wActiveSts & DI_STATUS_ACTIVE_HOME ) == DI_STATUS_ACTIVE_HOME )
		{
			m_ORG_ON.ShowWindow( TRUE );
			m_ORG_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_ORG_ON.ShowWindow( FALSE ); 
			m_ORG_OFF.ShowWindow( TRUE ); 
		}


		if( (wActiveSts & DI_STATUS_ACTIVE_NEARHOME ) == DI_STATUS_ACTIVE_NEARHOME )
		{
			m_NORG_ON.ShowWindow( TRUE );
			m_NORG_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_NORG_ON.ShowWindow( FALSE ); 
			m_NORG_OFF.ShowWindow( TRUE ); 
		}

		if( (wActiveSts & DI_STATUS_ACTIVE_INP ) == DI_STATUS_ACTIVE_INP )
		{
			m_INP_ON.ShowWindow( TRUE );
			m_INP_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_INP_ON.ShowWindow( FALSE ); 
			m_INP_OFF.ShowWindow( TRUE ); 
		}
		
		if( bIN3Sts == 0x01 )
		{
			m_IN3_ON.ShowWindow( TRUE );
			m_IN3_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_IN3_ON.ShowWindow( FALSE ); 
			m_IN3_OFF.ShowWindow( TRUE ); 
		}

	}


	CDialog::OnTimer(nIDEvent);
}
