// Line2_MoveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Line2_Move.h"
#include "Line2_MoveDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CLine2_MoveDlg dialog

CLine2_MoveDlg::CLine2_MoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLine2_MoveDlg::IDD, pParent)
	, m_nFinishPoint(5000000)
	, m_nFinishPoint2(8000000)
	, m_dwStartSpeed(1000)
	, m_dwDriveSpeed(500000)
	, m_dwAcce(800000)
	, m_dwDecel(600000)
	, m_strAcce(_T("Acceleration: "))
	, m_strDecel(_T("Deceleration: "))
	, m_nMoveType(0)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
	, m_ErrorOccure(0)
	, m_bStartMotion(false)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLine2_MoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_START, m_btMove);
	DDX_Control(pDX, IDC_BT_STOP, m_btStop);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
	DDX_Text(pDX, IDC_EDIT_P, m_nFinishPoint);
	DDX_Text(pDX, IDC_EDIT_P2, m_nFinishPoint2);
	DDX_Text(pDX, IDC_EDIT_SV, m_dwStartSpeed);
	DDX_Text(pDX, IDC_EDIT_V, m_dwDriveSpeed);
	DDX_Text(pDX, IDC_EDIT_A, m_dwAcce);
	DDX_Text(pDX, IDC_EDIT_D, m_dwDecel);
	DDX_Text(pDX, IDC_STATIC_ACC, m_strAcce);
	DDX_Text(pDX, IDC_STATIC_DEC, m_strDecel);
}

BEGIN_MESSAGE_MAP(CLine2_MoveDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RADIO_MOVE_TYPE, &CLine2_MoveDlg::OnConstMove)
	ON_BN_CLICKED(IDC_RADIO_MOVE_TYPE2, &CLine2_MoveDlg::OnTProfile)
	ON_BN_CLICKED(IDC_RADIO_MOVE_TYPE3, &CLine2_MoveDlg::OnSCurve)
	ON_BN_CLICKED(IDC_BT_START, &CLine2_MoveDlg::OnInterpStart)
	ON_BN_CLICKED(IDC_BT_STOP, &CLine2_MoveDlg::OnMotionStop)
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CLine2_MoveDlg::OnResetCounter)
	ON_UPDATE_COMMAND_UI(IDC_EDIT_SV, &CLine2_MoveDlg::OnUpdateStartSpeed)
END_MESSAGE_MAP()


// CLine2_MoveDlg message handlers

BOOL CLine2_MoveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	((CButton*) GetDlgItem(IDC_RADIO_MOVE_TYPE))->SetCheck( BST_CHECKED );

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st I8094
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Y, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}


				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Y, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Y, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}			
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CLine2_MoveDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_LINE2_MOVE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_LINE2_MOVE_DIALOG));
	}
}
#endif


void CLine2_MoveDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}		
}

void CLine2_MoveDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter, nEncPosition;
	DWORD dwCurSpeed;
	short nErrCode;
	BYTE bDone;
	WORD wStopStatus;
	CString strTmp;

	if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}
		
		if( (nErrCode =i8094_get_enccounter( m_CurSlotNo, AXIS_X, &nEncPosition )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_enccounter(AXIS_X) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_X) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		strTmp.Format( TEXT("%d"), nCmdCounter );
		SetDlgItemText( IDC_STATIC_LP, strTmp );

		strTmp.Format( TEXT("%d"), nEncPosition );
		SetDlgItemText( IDC_STATIC_EP, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeed );
		SetDlgItemText( IDC_STATIC_CV, strTmp );


		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Y, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}
		
		if( (nErrCode = i8094_get_enccounter( m_CurSlotNo, AXIS_Y, &nEncPosition )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_enccounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Y, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_Y) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		strTmp.Format( TEXT("%d"), nCmdCounter );
		SetDlgItemText( IDC_STATIC_LP2, strTmp );

		strTmp.Format( TEXT("%d"), nEncPosition );
		SetDlgItemText( IDC_STATIC_EP2, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeed );
		SetDlgItemText( IDC_STATIC_CV2, strTmp );

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}
		else
		{
			if( bDone == MOTION_DONE )
			{
				m_btStop.EnableWindow( FALSE );
				m_btMove.EnableWindow( TRUE );
				m_btClear.EnableWindow( TRUE );
			}	
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CLine2_MoveDlg::DetailedErrorMsg(short wErrAxes)
{
	WORD ErrorSts;
	CString strTmpMsg, strErrMsg;

	strErrMsg.Empty();


	if( (wErrAxes & AXIS_X) == AXIS_X )
	{
		i8094_get_error_status( m_CurSlotNo, AXIS_X, &ErrorSts );
		strTmpMsg.Format( TEXT(" Motion failed in AXIS_X, error status = 0x%04X\n"), ErrorSts );
		strErrMsg += strTmpMsg;
	}

	if( (wErrAxes & AXIS_Y) == AXIS_Y )
	{
		i8094_get_error_status( m_CurSlotNo, AXIS_Y, &ErrorSts );
		strTmpMsg.Format( TEXT(" Motion failed in AXIS_Y, error status = 0x%04X\n"), ErrorSts );
		strErrMsg += strTmpMsg;
	}



	if( !strErrMsg.IsEmpty() )
		AfxMessageBox( strErrMsg );
}

void CLine2_MoveDlg::OnConstMove()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
	m_nMoveType = 0;
	m_strAcce.Format( TEXT("Acceleration: ") );
	m_strDecel.Format( TEXT("Deceleration: ") );
	UpdateData( FALSE );
	
	UpdateDialogControls( this, FALSE );
}

void CLine2_MoveDlg::OnTProfile()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
	m_nMoveType = 1;
	m_strAcce.Format( TEXT("Acceleration: ") );
	m_strDecel.Format( TEXT("Deceleration: ") );
	UpdateData( FALSE );	

	UpdateDialogControls( this, FALSE );
}

void CLine2_MoveDlg::OnSCurve()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
	m_nMoveType = 2;
	m_strAcce.Format( TEXT("Acceleration Rate: ") );
	m_strDecel.Format( TEXT("Deceleration Rate: ") );
	UpdateData( FALSE );	

	UpdateDialogControls( this, FALSE );
}

void CLine2_MoveDlg::OnInterpStart()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;

	UpdateData(TRUE);

	switch( m_nMoveType )
	{
	case 0: // constant speed
		nErrCode = i8094_t_line2_move( m_CurSlotNo, AXIS_X, AXIS_Y, m_dwDriveSpeed,\
						  m_dwDriveSpeed, m_dwAcce, m_dwDecel, m_nFinishPoint, m_nFinishPoint2);
		break;
	case 1: // trapezoidal move
		nErrCode = i8094_t_line2_move( m_CurSlotNo, AXIS_X, AXIS_Y, m_dwStartSpeed,\
						  m_dwDriveSpeed, m_dwAcce, m_dwDecel, m_nFinishPoint, m_nFinishPoint2);
		break;
	case 2: // s-curve move 
		nErrCode = i8094_s_line2_move( m_CurSlotNo, AXIS_X, AXIS_Y, m_dwStartSpeed,\
						  m_dwDriveSpeed, m_dwAcce, m_dwDecel, m_nFinishPoint, m_nFinishPoint2);	
		break;
	}

	if( nErrCode != SUCCESS_NO_ERROR )
	{
		if( (nErrCode < ERROR_RUNTIME_BASE) && ( (ERROR_RUNTIME_BASE - 0x0F) < nErrCode ) )
		{
			WORD wAxes = (WORD)( abs(nErrCode) + ERROR_RUNTIME_BASE );
			DetailedErrorMsg(wAxes);
		}
		else
		{
			switch( m_nMoveType )
			{
			case 0: // constant speed
				strErrMsg.Format( TEXT("i8094_t_line2_move() falied with error code : %d"), nErrCode );
				break;
			case 1: // trapezoidal move
				strErrMsg.Format( TEXT("i8094_t_line2_move() falied with error code : %d"), nErrCode );
				break;
			case 2: // s-curve move 
				strErrMsg.Format( TEXT("i8094_s_line2_move() falied with error code : %d"), nErrCode );
				break;
			}

			AfxMessageBox( strErrMsg );
		}
	}
	else
	{
		m_btStop.EnableWindow( TRUE );
		m_btMove.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );

		m_bStartMotion = TRUE;
		m_ErrorOccure = 0x00;
	}	
}

void CLine2_MoveDlg::OnMotionStop()
{
	// TODO: Add your control notification handler code here
	BYTE bDone;
	WORD wStopStatus;
	short nErrCode;
	CString strErrMsg;

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_motion_done(AXIS_X) falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( bDone != MOTION_DONE )
	{
		if( (nErrCode = i8094_stop_move( m_CurSlotNo, AXIS_X, STOP_SLOWDOWN )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_stop_move(AXIS_Y) falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;		
		}
	}
	else
	{
		TRACE( TEXT(" Motion Done! Finish Status [0x%04X]\n"), wStopStatus );

	}

	m_btStop.EnableWindow( FALSE );
	m_btMove.EnableWindow( TRUE );
	m_btClear.EnableWindow( TRUE );
	m_bStartMotion = FALSE; 
}

void CLine2_MoveDlg::OnResetCounter()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
	
	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	
}

void CLine2_MoveDlg::OnUpdateStartSpeed(CCmdUI *pCmdUI)
{
	if( m_nMoveType == 0 ) // constant move
	{
		pCmdUI->Enable( FALSE );
	}
	else // trapezoidal or s-curve move 
	{
		pCmdUI->Enable( TRUE );
	}
}