// Line_MoveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Line_Move.h"
#include "Line_MoveDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CLine_MoveDlg dialog

CLine_MoveDlg::CLine_MoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLine_MoveDlg::IDD, pParent)
	, m_bSymmetric(FALSE)
	, m_strAcce(_T("Acceleration: "))
	, m_strDecel(_T("Deceleration: "))
	, m_dwStartSpeed(1000)
	, m_dwDriveSpeed(500000)
	, m_dwAcce(500000)
	, m_dwDecel(800000)
	, m_nFixedPulse(5000000)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nMoveType = 0; // constant speed
}

void CLine_MoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_START, m_btMove);
	DDX_Control(pDX, IDC_BT_STOP, m_btStop);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
	DDX_Check(pDX, IDC_CHECK_SYMMETRIC, m_bSymmetric);
	DDX_Text(pDX, IDC_STATIC_ACCE, m_strAcce);
	DDX_Text(pDX, IDC_STATIC_DECEL, m_strDecel);
	DDX_Text(pDX, IDC_EDIT_SV, m_dwStartSpeed);
	DDX_Text(pDX, IDC_EDIT_V, m_dwDriveSpeed);
	DDX_Text(pDX, IDC_EDIT_A, m_dwAcce);
	DDX_Text(pDX, IDC_EDIT_D, m_dwDecel);
	DDX_Text(pDX, IDC_EDIT_P, m_nFixedPulse);
}

BEGIN_MESSAGE_MAP(CLine_MoveDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_MOVE_TYPE, &CLine_MoveDlg::OnCnstSpeedClicked)
	ON_BN_CLICKED(IDC_RADIO_MOVE_TYPE2, &CLine_MoveDlg::OnTMoveClicked)
	ON_BN_CLICKED(IDC_RADIO_MOVE_TYPE3, &CLine_MoveDlg::OnSCurveClicked)
	ON_BN_CLICKED(IDC_BT_START, &CLine_MoveDlg::OnMotionStart)
	ON_BN_CLICKED(IDC_BT_STOP, &CLine_MoveDlg::OnMotionStop)
	ON_BN_CLICKED(IDC_CHECK_SYMMETRIC, &CLine_MoveDlg::OnCheckSymmetric)
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CLine_MoveDlg::OnResetCounter)
	ON_UPDATE_COMMAND_UI(IDC_EDIT_D, OnUpdateDeceleration)
	ON_UPDATE_COMMAND_UI(IDC_EDIT_SV, OnUpdateStartSpeed)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CLine_MoveDlg message handlers

BOOL CLine_MoveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				( (CButton*)(GetDlgItem( IDC_RADIO_MOVE_TYPE )) )->SetCheck( TRUE );
				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}			

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CLine_MoveDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_LINE_MOVE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_LINE_MOVE_DIALOG));
	}
}
#endif


void CLine_MoveDlg::OnCnstSpeedClicked()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
	m_strAcce.Format( TEXT("Acceleration: ") );
	m_strDecel.Format( TEXT("Deceleration: ") );
	UpdateData( FALSE );

	m_nMoveType = 0;

	UpdateDialogControls( this, FALSE );
}

void CLine_MoveDlg::OnTMoveClicked()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
	m_strAcce.Format( TEXT("Acceleration: ") );
	m_strDecel.Format( TEXT("Deceleration: ") );
	UpdateData( FALSE );	

	m_nMoveType = 1;

	UpdateDialogControls( this, FALSE );
}

void CLine_MoveDlg::OnSCurveClicked()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
	m_strAcce.Format( TEXT("Acceleration Rate: ") );
	m_strDecel.Format( TEXT("Deceleration Rate: ") );
	UpdateData( FALSE );	

	m_nMoveType = 2;

	UpdateDialogControls( this, FALSE );
}

void CLine_MoveDlg::OnMotionStart()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	WORD wErrorSts;
	short nErrCode;

	UpdateData(TRUE);

	switch( m_nMoveType )
	{
	case 0: // constant speed
		nErrCode = i8094_const_move( m_CurSlotNo, AXIS_X, m_dwDriveSpeed, m_nFixedPulse );
		break;
	case 1: // trapezoidal move
		nErrCode = i8094_t_move( m_CurSlotNo, AXIS_X, m_dwStartSpeed, m_dwDriveSpeed, m_dwAcce, m_dwDecel, m_nFixedPulse );
		break;
	case 2: // s-curve move 
		nErrCode = i8094_s_move( m_CurSlotNo, AXIS_X, m_dwStartSpeed, m_dwDriveSpeed, m_dwAcce, m_dwDecel, m_nFixedPulse );
		break;
	}

	if( nErrCode != SUCCESS_NO_ERROR )
	{
		if( (nErrCode < ERROR_RUNTIME_BASE) && ( (ERROR_RUNTIME_BASE - 0x0F) < nErrCode ) )
		{
			WORD wAxes = (WORD)( abs(nErrCode) + ERROR_RUNTIME_BASE );
			i8094_get_error_status( m_CurSlotNo, AXIS_X, &wErrorSts );
			DetailedErrorMsg(wErrorSts);
		}
		else
		{
			switch( m_nMoveType )
			{
			case 0: // constant speed
				strErrMsg.Format( TEXT("i8094_const_move() falied with error code : %d"), nErrCode );
				break;
			case 1: // trapezoidal move
				strErrMsg.Format( TEXT("i8094_t_move() falied with error code : %d"), nErrCode );
				break;
			case 2: // s-curve move 
				strErrMsg.Format( TEXT("i8094_s_move() falied with error code : %d"), nErrCode );
				break;
			}

			AfxMessageBox( strErrMsg );
		}
	}
	else
	{
		m_btStop.EnableWindow( TRUE );
		m_btMove.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );

		m_ErrorOccure = 0x00;
	}	
}

void CLine_MoveDlg::OnMotionStop()
{
	// TODO: Add your control notification handler code here
	BYTE bDone;
	WORD wStopStatus;
	short nErrCode;
	CString strErrMsg;

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( bDone != MOTION_DONE )
	{
		if( (nErrCode = i8094_stop_move( m_CurSlotNo, AXIS_X, STOP_SLOWDOWN )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT(" i8094_stop_move() failed, error code = %d\n"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}
	else
	{
		TRACE( TEXT(" Motion Done! Finish Status [0x%04X]\n"), wStopStatus );
	}	
}

void CLine_MoveDlg::DetailedErrorMsg(short wErrorSts)
{
	CString strTmpMsg, strErrMsg;

	strErrMsg.Format( TEXT(" Motion failed in AXIS_X, error status = ") );

	if( wErrorSts & DRIVE_ERROR_STATUS_SLMTP )
	{
		strTmpMsg.Format( TEXT("DRIVE_ERROR_STATUS_SLMTP") );
		strErrMsg += strTmpMsg;
	}

	if( wErrorSts & DRIVE_ERROR_STATUS_SLMTM )
	{
		strTmpMsg.Format( TEXT("DRIVE_ERROR_STATUS_SLMTM") );
		strErrMsg += strTmpMsg;
	}

	if( wErrorSts & DRIVE_ERROR_STATUS_LMTP )
	{
		strTmpMsg.Format( TEXT("DRIVE_ERROR_STATUS_LMTP") );
		strErrMsg += strTmpMsg;
	}

	if( wErrorSts & DRIVE_ERROR_STATUS_LMTM )
	{
		strTmpMsg.Format( TEXT("DRIVE_ERROR_STATUS_LMTM") );
		strErrMsg += strTmpMsg;
	}

	if( wErrorSts & DRIVE_ERROR_STATUS_ALARM )
	{
		strTmpMsg.Format( TEXT("DRIVE_ERROR_STATUS_ALARM") );
		strErrMsg += strTmpMsg;
	}

	if( wErrorSts & DRIVE_ERROR_STATUS_EMG )
	{
		strTmpMsg.Format( TEXT("DRIVE_ERROR_STATUS_EMG") );
		strErrMsg += strTmpMsg;
	}


	if( strErrMsg  != TEXT(" i8094_t_move() failed in AXIS_X, error status = ") )
		AfxMessageBox( strErrMsg );
}

void CLine_MoveDlg::OnCheckSymmetric()
{
	// TODO: Add your control notification handler code here
	CString strTmp;

	UpdateData(TRUE);

	if( m_bSymmetric == FALSE )
	{
		strTmp.Format( TEXT("%d") ,m_dwOldDecel );
		SetDlgItemText( IDC_EDIT_D, strTmp );
	}
	else
	{
		strTmp.Format( TEXT("%d") ,m_dwAcce );
		SetDlgItemText( IDC_EDIT_D, strTmp );
		m_dwOldDecel = m_dwDecel; // backup m_dwDecel
	}
}

void CLine_MoveDlg::OnResetCounter()
{
	// TODO: Add your control notification handler code here
	short nError;

	if( (nError = i8094_set_enccounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		TRACE( TEXT(" i8094_set_enccounter() failed, error code = %d\n"), nError );
	}
	
	if( (nError = i8094_set_cmdcounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		TRACE( TEXT(" i8094_set_cmdcounter() failed, error code = %d\n"), nError );
	}
}

void CLine_MoveDlg::OnUpdateDeceleration(CCmdUI *pCmdUI)
{
	if( m_bSymmetric == FALSE )
	{
		pCmdUI->Enable( TRUE );
	}
	else
	{
		pCmdUI->Enable( FALSE );
	}
}

void CLine_MoveDlg::OnUpdateStartSpeed(CCmdUI *pCmdUI)
{
	if( m_nMoveType == 0 ) // constant move
	{
		pCmdUI->Enable( FALSE );
	}
	else // trapezoidal or s-curve move 
	{
		pCmdUI->Enable( TRUE );
	}
}

void CLine_MoveDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}		
}

void CLine_MoveDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter, nEncPosition;
	DWORD dwCurSpeed, dwCurAcceleration;
	BYTE bDone;
	WORD wStopStatus;
	short nErrCode;
	CString strTmp;

	if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}
		
		if( (nErrCode = i8094_get_enccounter( m_CurSlotNo, AXIS_X, &nEncPosition )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_enccounter() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_acc( m_CurSlotNo, AXIS_X, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}
		else
		{
			if( bDone == MOTION_DONE )
			{
				m_btStop.EnableWindow( FALSE );
				m_btMove.EnableWindow( TRUE );
				m_btClear.EnableWindow( TRUE );
			}	
		}

		strTmp.Format( TEXT("%d"), nCmdCounter );
		SetDlgItemText( IDC_STATIC_LP, strTmp );

		strTmp.Format( TEXT("%d"), nEncPosition );
		SetDlgItemText( IDC_STATIC_EP, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeed );
		SetDlgItemText( IDC_STATIC_CV, strTmp );

		strTmp.Format( TEXT("%d"), dwCurAcceleration );
		SetDlgItemText( IDC_STATIC_CA, strTmp );
	}

	CDialog::OnTimer(nIDEvent);
}
