// Line_MoveAllDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Line_MoveAll.h"
#include "Line_MoveAllDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CLine_MoveAllDlg dialog

CLine_MoveAllDlg::CLine_MoveAllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLine_MoveAllDlg::IDD, pParent)
	, m_dwA_X(500000)
	, m_dwA_Y(500000)
	, m_dwA_Z(500000)
	, m_dwD_X(800000)
	, m_dwD_Y(800000)
	, m_dwD_Z(800000)
	, m_nP_X(7000000)
	, m_nP_Y(6000000)
	, m_nP_Z(5000000)
	, m_dwSV_X(1000)
	, m_dwSV_Y(1000)
	, m_dwSV_Z(1000)
	, m_dwV_X(500000)
	, m_dwV_Y(600000)
	, m_dwV_Z(700000)
	, m_nMoveType(0)
	, m_strAcce(_T("Acceleration: "))
	, m_strDecel(_T("Deceleration: "))
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
	,m_ErrorOccure(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLine_MoveAllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_STOP, m_btStop);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
	DDX_Control(pDX, IDC_BT_START, m_btMove);
	DDX_Text(pDX, IDC_EDIT_A, m_dwA_X);
	DDX_Text(pDX, IDC_EDIT_A2, m_dwA_Y);
	DDX_Text(pDX, IDC_EDIT_A3, m_dwA_Z);
	DDX_Text(pDX, IDC_EDIT_D, m_dwD_X);
	DDX_Text(pDX, IDC_EDIT_D2, m_dwD_Y);
	DDX_Text(pDX, IDC_EDIT_D3, m_dwD_Z);
	DDX_Text(pDX, IDC_EDIT_P, m_nP_X);
	DDX_Text(pDX, IDC_EDIT_P2, m_nP_Y);
	DDX_Text(pDX, IDC_EDIT_P3, m_nP_Z);
	DDX_Text(pDX, IDC_EDIT_SV, m_dwSV_X);
	DDX_Text(pDX, IDC_EDIT_SV2, m_dwSV_Y);
	DDX_Text(pDX, IDC_EDIT_SV3, m_dwSV_Z);
	DDX_Text(pDX, IDC_EDIT_V, m_dwV_X);
	DDX_Text(pDX, IDC_EDIT_V2, m_dwV_Y);
	DDX_Text(pDX, IDC_EDIT_V3, m_dwV_Z);
	DDX_Radio(pDX, IDC_RADIO_MOVE_TYPE, m_nMoveType);
	DDX_Text(pDX, IDC_STATIC_ACCE, m_strAcce);
	DDX_Text(pDX, IDC_STATIC_DECEL, m_strDecel);
}

BEGIN_MESSAGE_MAP(CLine_MoveAllDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CLine_MoveAllDlg::OnResetCnter)
	ON_BN_CLICKED(IDC_BT_STOP, &CLine_MoveAllDlg::OnStopMove)
	ON_BN_CLICKED(IDC_BT_START, &CLine_MoveAllDlg::OnStartMove)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CLine_MoveAllDlg message handlers

BOOL CLine_MoveAllDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st I8094/F
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Y, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Z, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_Z) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Y, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Z, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_Z) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Y, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Z, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_Z) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}


				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}		
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CLine_MoveAllDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_LINE_MOVEALL_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_LINE_MOVEALL_DIALOG));
	}
}
#endif


void CLine_MoveAllDlg::DetailedErrorMsg(WORD wErrAxes)
{
	WORD ErrorSts;
	CString strTmpMsg, strErrMsg;

	strErrMsg.Empty();

	if( (wErrAxes & AXIS_X) == AXIS_X )
	{
		i8094_get_error_status( m_CurSlotNo, AXIS_X, &ErrorSts );
		strTmpMsg.Format( TEXT(" Motion failed in AXIS_X, error status = 0x%04X\n"), ErrorSts );
		strErrMsg += strTmpMsg;
	}

	if( (wErrAxes & AXIS_Y) == AXIS_Y )
	{
		i8094_get_error_status( m_CurSlotNo, AXIS_Y, &ErrorSts );
		strTmpMsg.Format( TEXT(" Motion failed in AXIS_Y, error status = 0x%04X\n"), ErrorSts );
		strErrMsg += strTmpMsg;
	}

	if( (wErrAxes & AXIS_Z) == AXIS_Z )
	{
		i8094_get_error_status( m_CurSlotNo, AXIS_Z, &ErrorSts );
		strTmpMsg.Format( TEXT(" Motion failed in AXIS_Z, error status = 0x%04X\n"), ErrorSts );
		strErrMsg += strTmpMsg;
	}

	if( !strErrMsg.IsEmpty() )
		AfxMessageBox( strErrMsg );
}

void CLine_MoveAllDlg::OnResetCnter()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	
	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		TRACE( TEXT(" i8094_set_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
	}	

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		TRACE( TEXT(" i8094_set_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
	}

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Z, (long)0 )) != SUCCESS_NO_ERROR )
	{
		TRACE( TEXT(" i8094_set_cmdcounter(AXIS_Z) failed, error code = %d\n"), nErrCode );
	}	

}

void CLine_MoveAllDlg::OnStopMove()
{
	// TODO: Add your control notification handler code here
	BYTE bDoneX, bDoneY, bDoneZ;
	WORD wStopStatus;
	short nErrCode;
	CString strErrMsg;

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDoneX, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8092_motion_done(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_Y, &bDoneY, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8092_motion_done(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_Z, &bDoneZ, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_motion_done(AXIS_Z) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (bDoneX != MOTION_DONE) && (bDoneY != MOTION_DONE) && (bDoneZ != MOTION_DONE) )
	{
		if( (nErrCode = i8094_stop_move_all( m_CurSlotNo, (AXIS_X|AXIS_Y|AXIS_Z), STOP_SLOWDOWN )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT(" i8092_stop_move_all() failed, error code = %d\n"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
		else
		{
			m_btStop.EnableWindow( FALSE );
			m_btMove.EnableWindow( TRUE );
			m_btClear.EnableWindow( TRUE );
		}
	}		
}

void CLine_MoveAllDlg::OnStartMove()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	DWORD dwStartSpeed[4];			/* Start Speed */
	DWORD dwDriveSpeed[4];			/* Driving Speed */
	DWORD dwAcce[4];				/* Acceleration */
	DWORD dwDecel[4];				/* Deceleration */
    long  FixedPulse[4];			/* total driving pulse */

	UpdateData(TRUE);

	dwStartSpeed[0] = m_dwSV_X; dwStartSpeed[1] = m_dwSV_Y; dwStartSpeed[2] = m_dwSV_Z;
	dwDriveSpeed[0] = m_dwV_X;  dwDriveSpeed[1] = m_dwV_Y;  dwDriveSpeed[2] = m_dwV_Z;
	dwAcce[0] = m_dwA_X; dwAcce[1] = m_dwA_Y; dwAcce[2] = m_dwA_Z;
	dwDecel[0] = m_dwD_X; dwDecel[1] = m_dwD_Y; dwDecel[2] = m_dwD_Z;
	FixedPulse[0] = m_nP_X; FixedPulse[1] = m_nP_Y; FixedPulse[2] = m_nP_Z;


	switch( m_nMoveType )
	{
	case 0: // constant speed
		nErrCode = i8094_const_moveall( m_CurSlotNo, (AXIS_X|AXIS_Y|AXIS_Z), dwDriveSpeed, FixedPulse );
		break;
	case 1: // trapezoidal move
		nErrCode = i8094_t_moveall( m_CurSlotNo, (AXIS_X|AXIS_Y|AXIS_Z), dwStartSpeed, dwDriveSpeed, dwAcce, dwDecel, FixedPulse );
		break;
	case 2: // s-curve move 
		nErrCode = i8094_s_moveall( m_CurSlotNo, (AXIS_X|AXIS_Y|AXIS_Z), dwStartSpeed, dwDriveSpeed, dwAcce, dwDecel, FixedPulse );
		break;
	}

	if( nErrCode != SUCCESS_NO_ERROR )
	{
		if( (nErrCode < ERROR_RUNTIME_BASE) && ( (ERROR_RUNTIME_BASE - 0x0F) < nErrCode ) )
		{
			WORD wAxes = (WORD)( abs(nErrCode) + ERROR_RUNTIME_BASE );
			DetailedErrorMsg(wAxes);
		}
		else
		{
			switch( m_nMoveType )
			{
			case 0: // constant speed
				strErrMsg.Format( TEXT("i8092_const_moveall() falied with error code : %d"), nErrCode );
				break;
			case 1: // trapezoidal move
				strErrMsg.Format( TEXT("i8092_t_moveall() falied with error code : %d"), nErrCode );
				break;
			case 2: // s-curve move 
				strErrMsg.Format( TEXT("i8092_s_moveall() falied with error code : %d"), nErrCode );
				break;
			}

			AfxMessageBox( strErrMsg );
		}
	}
	else
	{
		m_btStop.EnableWindow( TRUE );
		m_btMove.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );

		m_ErrorOccure = 0x00;
	}		
}

void CLine_MoveAllDlg::OnTimer(UINT_PTR nIDEvent)
{

	// TODO: Add your message handler code here and/or call default
	long nCmdCounterX, nCmdCounterY, nCmdCounterZ;
	DWORD dwCurSpeedX, dwCurSpeedY, dwCurSpeedZ;
	BYTE bDoneX, bDoneY, bDoneZ;

	WORD wStopStatus;
	short nErrCode;
	CString strTmp;

	if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounterX )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Y, &nCmdCounterY )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Z, &nCmdCounterZ )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Z) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeedX )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_X) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Y, &dwCurSpeedY )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_Y) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Z, &dwCurSpeedZ )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_Z) failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDoneX, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_Y, &bDoneY, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_Z, &bDoneZ, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (bDoneX == MOTION_DONE) && (bDoneY == MOTION_DONE) && (bDoneZ == MOTION_DONE) )
		{

			m_btStop.EnableWindow( FALSE );
			m_btMove.EnableWindow( TRUE );
			m_btClear.EnableWindow( TRUE );
		}

		strTmp.Format( TEXT("%d"), nCmdCounterX );
		SetDlgItemText( IDC_STATIC_LP, strTmp );

		strTmp.Format( TEXT("%d"), nCmdCounterY );
		SetDlgItemText( IDC_STATIC_LP2, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeedX );
		SetDlgItemText( IDC_STATIC_CV, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeedY );
		SetDlgItemText( IDC_STATIC_CV2, strTmp );

		strTmp.Format( TEXT("%d"), nCmdCounterZ );
		SetDlgItemText( IDC_STATIC_LP3, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeedZ );
		SetDlgItemText( IDC_STATIC_CV3, strTmp );


	}

	CDialog::OnTimer(nIDEvent);
}
