// Scan_CardDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Scan_Card.h"
#include "Scan_CardDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CScan_CardDlg dialog

CScan_CardDlg::CScan_CardDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScan_CardDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScan_CardDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CARD, m_ListCard);
}

BEGIN_MESSAGE_MAP(CScan_CardDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BT_SCAN, &CScan_CardDlg::OnScanCard)
END_MESSAGE_MAP()


// CScan_CardDlg message handlers

BOOL CScan_CardDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CScan_CardDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SCAN_CARD_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SCAN_CARD_DIALOG));
	}
}
#endif


void CScan_CardDlg::OnScanCard()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		int i;
		BYTE bSlotNo;
		CString strModuleInfo;

		// delete available ListBox item
		for (i = m_ListCard.GetCount()-1; i >= 0; i--)
			m_ListCard.DeleteString( i );

		// add available PISO-PS400

		for( i=0; i<m_ModuleNum; i++ )
		{
			if( (nErrCode = i8094_get_cardinfo( i, &bSlotNo )) == SUCCESS_NO_ERROR )
			{
				strModuleInfo.Format( TEXT("I8094 at Slot%d"), bSlotNo );
				m_ListCard.AddString(strModuleInfo);
			}

		}
	}	
	else
	{
		if( nErrCode == ERROR_NO_CARD_FOUND )
			AfxMessageBox( TEXT("No I8094 is available on your system, please check the system") );
	}	
}
