// Set_RangeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Set_Range.h"
#include "Set_RangeDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define wTarget_Axis		AXIS_X

// CSet_RangeDlg dialog

CSet_RangeDlg::CSet_RangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSet_RangeDlg::IDD, pParent)
	, m_strVRange(_T(""))
	, m_strARange(_T(""))
	, m_strKRange(_T(""))
	, m_dwRange(16000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSet_RangeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_SET_RANGE, m_btSetRange);
	DDX_Text(pDX, IDC_EDIT_V_RANGE, m_strVRange);
	DDV_MaxChars(pDX, m_strVRange, 30);
	DDX_Text(pDX, IDC_EDIT_A_RANGE, m_strARange);
	DDV_MaxChars(pDX, m_strARange, 30);
	DDX_Text(pDX, IDC_EDIT_K_RANGE, m_strKRange);
	DDV_MaxChars(pDX, m_strKRange, 30);
	DDX_Text(pDX, IDC_EDIT_RANGE, m_dwRange);
	DDV_MinMaxUInt(pDX, m_dwRange, 16000, 8000000);
}

BEGIN_MESSAGE_MAP(CSet_RangeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BT_SET_RANGE, &CSet_RangeDlg::OnSetRange)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CSet_RangeDlg message handlers

BOOL CSet_RangeDlg::OnInitDialog()
{
	AXIS_RANGE_SETTINGS AxisRangeSetting;

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st I8092
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{
			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;
				m_btSetRange.EnableWindow( TRUE );

				if( (nErrCode = i8094_get_range_settings( m_CurSlotNo, wTarget_Axis, &AxisRangeSetting )) == SUCCESS_NO_ERROR )
				{
					m_strVRange.Format( TEXT("%d ~ %d"), AxisRangeSetting.Speed_Min, AxisRangeSetting.Speed_Max );
					m_strARange.Format( TEXT("%d ~ %d"), AxisRangeSetting.Acce_Min, AxisRangeSetting.Acce_Max );
					m_strKRange.Format( TEXT("%.0f ~ %.0f"), (float)( AxisRangeSetting.AcceRate_Min), (float)(AxisRangeSetting.AcceRate_Max) );

					UpdateData( FALSE );
				}
				else
				{
					strErrMsg.Format( TEXT("i8094_set_range() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
				}

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSet_RangeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SET_RANGE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SET_RANGE_DIALOG));
	}
}
#endif


void CSet_RangeDlg::OnSetRange()
{
	// TODO: Add your message handler code here
	CString strErrMsg, strRange;	
	short nErrCode;
	AXIS_RANGE_SETTINGS AxisRangeSetting;

	UpdateData( TRUE );

	if( (nErrCode = i8094_set_range( m_CurSlotNo, wTarget_Axis, m_dwRange )) == SUCCESS_NO_ERROR )
	{
		if( (nErrCode = i8094_get_range_settings( m_CurSlotNo, wTarget_Axis, &AxisRangeSetting )) == SUCCESS_NO_ERROR )
		{
			m_strVRange.Format( TEXT("%d ~ %d"), AxisRangeSetting.Speed_Min, AxisRangeSetting.Speed_Max );
			m_strARange.Format( TEXT("%d ~ %d"), AxisRangeSetting.Acce_Min, AxisRangeSetting.Acce_Max );
			m_strKRange.Format( TEXT("%.0f ~ %.0f"), (float)( AxisRangeSetting.AcceRate_Min), (float)(AxisRangeSetting.AcceRate_Max) );

			UpdateData( FALSE );
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_set_range() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}
	}
	else
	{
		strErrMsg.Format( TEXT("i8094_set_range() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}	
}

void CSet_RangeDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	CString strErrMsg;	
	short nErrCode;

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nErrCode = i8094_close( m_CurSlotNo )) == SUCCESS_NO_ERROR )
		{
			m_CurSlotNo = INVALID_SLOT_NUMBER;
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_close() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}
	}	
}
