// Synch_ActionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Synch_Action.h"
#include "Synch_ActionDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSynch_ActionDlg dialog

CSynch_ActionDlg::CSynch_ActionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSynch_ActionDlg::IDD, pParent)
	, m_nSyncCondition(0)
	, m_nSyncAction(0)
	, m_strCA_X(_T(""))
	, m_strCA_Y(_T(""))
	, m_strCV_X(_T(""))
	, m_strCV_Y(_T(""))
	, m_strLP_X(_T(""))
	, m_strLP_Y(_T(""))
	, m_nComparatorM(0)
	, m_nComparatorP(0)
	, m_dwStartSpeed(50000)
	, m_dwAcce(1000000)
	, m_dwDriveSpeed(500000)
	, m_nFixedPulse(5000000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSynch_ActionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
	DDX_Control(pDX, IDC_BT_START, m_btMove);
	DDX_Radio(pDX, IDC_RADIO_EXCEED_CMP_PLUSE, m_nSyncCondition);
	DDX_Radio(pDX, IDC_RADIO_FIXED_FORWARD_DRIVE, m_nSyncAction);
	DDX_Text(pDX, IDC_EDIT_CMPP, m_nComparatorP);
	DDX_Text(pDX, IDC_EDIT_CMPM, m_nComparatorM);
	DDX_Text(pDX, IDC_STATIC_CA, m_strCA_X);
	DDX_Text(pDX, IDC_STATIC_CA2, m_strCA_Y);
	DDX_Text(pDX, IDC_STATIC_CV, m_strCV_X);
	DDX_Text(pDX, IDC_STATIC_CV2, m_strCV_Y);
	DDX_Text(pDX, IDC_STATIC_LP, m_strLP_X);
	DDX_Text(pDX, IDC_STATIC_LP2, m_strLP_Y);
}

BEGIN_MESSAGE_MAP(CSynch_ActionDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_CONTINUE_FORWARD_DRIVE, &CSynch_ActionDlg::OnRadioContinueForwardDrive)
	ON_BN_CLICKED(IDC_RADIO_CONTINUE_REVERSE_DRIVE, &CSynch_ActionDlg::OnRadioContinueReverseDrive)
	ON_BN_CLICKED(IDC_RADIO_SLOWDOWN_STOP, &CSynch_ActionDlg::OnRadioSlowdownStop)
	ON_BN_CLICKED(IDC_RADIO_SUDDEN_STOP, &CSynch_ActionDlg::OnRadioSuddenStop)
	ON_BN_CLICKED(IDC_RADIO_START_DRIVE, &CSynch_ActionDlg::OnRadioStartDrive)
	ON_BN_CLICKED(IDC_RADIO_END_DRIVE, &CSynch_ActionDlg::OnRadioEndDrive)
	ON_BN_CLICKED(IDC_RADIO_EXCEED_CMP_PLUSE, &CSynch_ActionDlg::OnExceedCmpPlus)
	ON_BN_CLICKED(IDC_RADIO_LESS_CMP_PLUSE, &CSynch_ActionDlg::OnLessCmpPlus)
	ON_BN_CLICKED(IDC_RADIO_LESS_CMP_MINUS, &CSynch_ActionDlg::OnLessCmpMinus)
	ON_BN_CLICKED(IDC_RADIO_EXCEED_CMP_MINUS, &CSynch_ActionDlg::OnExceedCmpMinus)
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CSynch_ActionDlg::OnResetCounter)
	ON_BN_CLICKED(IDC_BT_START, &CSynch_ActionDlg::OnMoveStart)
	ON_BN_CLICKED(IDC_RADIO_FIXED_FORWARD_DRIVE, &CSynch_ActionDlg::OnRadioFixedForwardDrive)
	ON_BN_CLICKED(IDC_RADIO_FIXED_REVERSE_DRIVE, &CSynch_ActionDlg::OnRadioFixedReverseDrive)
	ON_UPDATE_COMMAND_UI(IDC_EDIT_CMPP, &CSynch_ActionDlg::OnUpdateCMPP)
	ON_UPDATE_COMMAND_UI(IDC_EDIT_CMPM, &CSynch_ActionDlg::OnUpdateCMPM)
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CSynch_ActionDlg message handlers

BOOL CSynch_ActionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	CString strErrMsg;	
	long lCmdCounter;
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Y, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Y, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Y, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &lCmdCounter )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_get_cmdcounter() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;			
				}
				else
				{
					m_nComparatorP = lCmdCounter + 2500000L;
					m_nComparatorM = lCmdCounter - 2500000L;

					UpdateData( FALSE );
				}

				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}			

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSynch_ActionDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SYNCH_ACTION_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SYNCH_ACTION_DIALOG));
	}
}
#endif

void CSynch_ActionDlg::OnResetCounter() 
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
	long lCmdCounter;
	
	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &lCmdCounter )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_get_cmdcounter() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}
	else
	{
		m_nComparatorP = lCmdCounter + 2500000L;
		m_nComparatorM = lCmdCounter - 2500000L;

		UpdateData( FALSE );
	}	
}

void CSynch_ActionDlg::OnMoveStart()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
    WORD   wSyncCondition;
	WORD   wSyncActionOtherAxis;
	long   nFixedPulse;

	UpdateData( TRUE );

	switch( m_nSyncCondition )
	{
	case 0:
		wSyncCondition = SYNC_CONDITION_EXCEED_CMP_POSITIVE;
		nFixedPulse = (long)m_nFixedPulse;
		break;

	case 1:
		wSyncCondition = SYNC_CONDITION_LESS_CMP_POSITIVE;
		nFixedPulse = (long)(0 - m_nFixedPulse);
		break;

	case 2:
		wSyncCondition = SYNC_CONDITION_LESS_CMP_NEGATIVE;
		nFixedPulse = (long)(0 - m_nFixedPulse);
		break;

	case 3:
		wSyncCondition = SYNC_CONDITION_EXCEED_CMP_NEGATIVE;
		nFixedPulse = (long)m_nFixedPulse;
		break;

	case 4:
		wSyncCondition = SYNC_CONDITION_START_DRIVING;
		nFixedPulse = (long)m_nFixedPulse;
		break;

	case 5:
		wSyncCondition = SYNC_CONDITION_END_DRIVING;
		nFixedPulse = (long)m_nFixedPulse;
		break;

	default:
		wSyncCondition = SYNC_CONDITION_NONE;
		break;
	}


	switch( m_nSyncAction )
	{
	case 0:
		wSyncActionOtherAxis = SYNC_ACTION_FIXED_FORWARD_DRIVE;
		break;

	case 1:
		wSyncActionOtherAxis = SYNC_ACTION_FIXED_REVERSE_DRIVE;
		break;

	case 2:
		wSyncActionOtherAxis = SYNC_ACTION_CONTINUE_FORWARD_DRIVE;
		break;

	case 3:
		wSyncActionOtherAxis = SYNC_ACTION_CONTINUE_REVERSE_DRIVE;
		break;

	case 4:
		wSyncActionOtherAxis = SYNC_ACTION_SLOWDOWN_STOP;
		break;

	case 5:
		wSyncActionOtherAxis = SYNC_ACTION_SUDDEN_STOP;
		break;

	default:
		wSyncActionOtherAxis = SYNC_ACTION_NONE;
		break;
	}

	if( (nErrCode = i8094_set_synch( m_CurSlotNo, AXIS_X, SYNC_ENABLE_FEATURE, AXIS_Y,\
								wSyncCondition, SYNC_ACTION_NONE, wSyncActionOtherAxis,\
								CMP_SRC_LOGIC_COMMAND, m_nComparatorP, m_nComparatorM )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_synch(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}


	if( (m_nSyncAction != 4) && (m_nSyncAction != 5) )
	{
		if( (nErrCode = i8094_synch_t_move_cfg( m_CurSlotNo, AXIS_Y, 10000, 50000, 100000, 100000, 300000 )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT(" i8094_synch_t_move_cfg(AXIS_Y) failed, error code = %d\n"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}

	if( (nErrCode = i8094_t_move( m_CurSlotNo, AXIS_X, m_dwStartSpeed, m_dwDriveSpeed, m_dwAcce, m_dwAcce, nFixedPulse )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_t_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}
	else
	{
		m_btMove.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );
	}	
}

void CSynch_ActionDlg::OnExceedCmpMinus() 
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	long lCmdCounter;

	UpdateData(TRUE); // to update m_SyncCondition		

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &lCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		}
		else
		{
			m_nComparatorP = lCmdCounter + 5000000L;
			m_nComparatorM = lCmdCounter + 2500000L;
			UpdateData( FALSE );

			UpdateDialogControls( this, FALSE );
		}
	}	
}

void CSynch_ActionDlg::OnExceedCmpPlus() 
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	long lCmdCounter;

	UpdateData(TRUE); // to update m_SyncCondition

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &lCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		}
		else
		{
			m_nComparatorP = lCmdCounter + 2500000L;
			m_nComparatorM = lCmdCounter - 2500000L;
			UpdateData( FALSE );

			UpdateDialogControls( this, FALSE );
		}
	}	
}

void CSynch_ActionDlg::OnLessCmpMinus() 
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	long lCmdCounter;

	UpdateData(TRUE); // to update m_SyncCondition		

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &lCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		}
		else
		{
			m_nComparatorP = lCmdCounter + 2500000L;
			m_nComparatorM = lCmdCounter - 2500000L;
			UpdateData( FALSE );

			UpdateDialogControls( this, FALSE );
		}
	}	
}

void CSynch_ActionDlg::OnLessCmpPlus() 
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	long lCmdCounter;

	UpdateData(TRUE); // to update m_SyncCondition	

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &lCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" ps400_set_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		}
		else
		{
			m_nComparatorP = lCmdCounter - 2500000L;
			m_nComparatorM = lCmdCounter - 5000000L;
			UpdateData( FALSE );

			UpdateDialogControls( this, FALSE );
		}
	}	
}

void CSynch_ActionDlg::OnRadioContinueForwardDrive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);	
}

void CSynch_ActionDlg::OnRadioContinueReverseDrive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);	
}

void CSynch_ActionDlg::OnRadioStartDrive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	UpdateDialogControls( this, FALSE );

}

void CSynch_ActionDlg::OnRadioEndDrive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);	

	UpdateDialogControls( this, FALSE );

}

void CSynch_ActionDlg::OnRadioFixedForwardDrive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSynch_ActionDlg::OnRadioFixedReverseDrive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSynch_ActionDlg::OnRadioSlowdownStop() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSynch_ActionDlg::OnRadioSuddenStop() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSynch_ActionDlg::OnUpdateCMPP(CCmdUI *pCmdUI)
{

	if( (m_nSyncCondition == 4) || (m_nSyncCondition == 5) )
	{
		pCmdUI->Enable( FALSE );
	}
	else 
	{
		pCmdUI->Enable( TRUE );
	}
}

void CSynch_ActionDlg::OnUpdateCMPM(CCmdUI *pCmdUI)
{

	if( (m_nSyncCondition == 4) || (m_nSyncCondition == 5) )
	{
		pCmdUI->Enable( FALSE );
	}
	else 
	{
		pCmdUI->Enable( TRUE );
	}
}

void CSynch_ActionDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter;
	DWORD dwCurSpeed, dwCurAcceleration;
	short nErrCode;
	BYTE bDone;
	WORD wStopStatus;
	CString strTmp;

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		}
		
		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_X) failed, error code = %d\n"), nErrCode );
		}

		if( (nErrCode = i8094_get_acc( m_CurSlotNo, AXIS_X, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc(AXIS_X) failed, error code = %d\n"), nErrCode );
		}

		m_strLP_X.Format( TEXT("%d"), nCmdCounter );
		m_strCV_X.Format( TEXT("%d"), dwCurSpeed );
		m_strCA_X.Format( TEXT("%d"), dwCurAcceleration );

		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Y, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		}
		
		if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Y, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed(AXIS_Y) failed, error code = %d\n"), nErrCode );
		}

		if( (nErrCode = i8094_get_acc( m_CurSlotNo, AXIS_Y, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc(AXIS_Y) failed, error code = %d\n"), nErrCode );
		}

		m_strLP_Y.Format( TEXT("%d"), nCmdCounter );
		m_strCV_Y.Format( TEXT("%d"), dwCurSpeed );
		m_strCA_Y.Format( TEXT("%d"), dwCurAcceleration );

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
		}
		else
		{
			if( bDone == MOTION_DONE )
			{
				m_btMove.EnableWindow( TRUE );
				m_btClear.EnableWindow( TRUE );
			}	
		}

		UpdateData( FALSE );
	}	

	CDialog::OnTimer(nIDEvent);
}

void CSynch_ActionDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
	{
		KillTimer( nTimer );
		nTimer = -1;
	}

	
	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_set_synch( m_CurSlotNo, AXIS_X, SYNC_DISABLE_FEATURE, AXIS_Y, SYNC_CONDITION_NONE, SYNC_ACTION_NONE, SYNC_ACTION_NONE, 0x00, 0x00, 0x00 );
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}	
}
