// Velocity_MoveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Velocity_Move.h"
#include "Velocity_MoveDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define wTarget_Axis		AXIS_X

// CVelocity_MoveDlg dialog

CVelocity_MoveDlg::CVelocity_MoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVelocity_MoveDlg::IDD, pParent)
	, m_strCV(_T(""))
	, m_strCA(_T(""))
	, m_strEP(_T(""))
	, m_strLP(_T(""))
	, m_dwStartSpeed(1000)
	, m_dwDriveSpeed(500000)
	, m_dwAcce(200000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVelocity_MoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_MOVE, m_btMove);
	DDX_Control(pDX, IDC_BT_STOP, m_btStop);
	DDX_Control(pDX, IDC_BT_COUNTER_CLEAR, m_btClear);
	DDX_Text(pDX, IDC_STATIC_CV, m_strCV);
	DDX_Text(pDX, IDC_STATIC_CA, m_strCA);
	DDX_Text(pDX, IDC_STATIC_EP, m_strEP);
	DDX_Text(pDX, IDC_STATIC_LP, m_strLP);
	DDX_Text(pDX, IDC_EDIT_SV, m_dwStartSpeed);
	DDX_Text(pDX, IDC_EDIT_V, m_dwDriveSpeed);
	DDX_Text(pDX, IDC_EDIT_A, m_dwAcce);
}

BEGIN_MESSAGE_MAP(CVelocity_MoveDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BT_MOVE, &CVelocity_MoveDlg::OnVelocityMove)
	ON_BN_CLICKED(IDC_BT_COUNTER_CLEAR, &CVelocity_MoveDlg::OnCounterClear)
	ON_BN_CLICKED(IDC_BT_STOP, &CVelocity_MoveDlg::OnMotionStop)
END_MESSAGE_MAP()


// CVelocity_MoveDlg message handlers

BOOL CVelocity_MoveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, wTarget_Axis, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, wTarget_Axis, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, wTarget_Axis, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}		

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CVelocity_MoveDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_VELOCITY_MOVE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_VELOCITY_MOVE_DIALOG));
	}
}
#endif


void CVelocity_MoveDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}	
}

void CVelocity_MoveDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter, nEncPosition;
	DWORD dwCurSpeed, dwCurAcceleration;
	short nError;
	CString strTmp;

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nError = i8094_get_cmdcounter( m_CurSlotNo, wTarget_Axis, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter() failed, error code = %d\n"), nError );
		}
		
		if( (nError = i8094_get_enccounter( m_CurSlotNo, wTarget_Axis, &nEncPosition )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_enccounter() failed, error code = %d\n"), nError );
		}

		if( (nError = i8094_get_speed( m_CurSlotNo, wTarget_Axis, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed() failed, error code = %d\n"), nError );
		}

		if( (nError = i8094_get_acc( m_CurSlotNo, wTarget_Axis, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc() failed, error code = %d\n"), nError );
		}

		m_strLP.Format( TEXT("%d"), nCmdCounter );

		m_strEP.Format( TEXT("%d"), nEncPosition );

		m_strCV.Format( TEXT("%d"), dwCurSpeed );

		m_strCA.Format( TEXT("%d"), dwCurAcceleration );

		UpdateData( FALSE );
	}	

	CDialog::OnTimer(nIDEvent);
}

void CVelocity_MoveDlg::OnVelocityMove()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	UpdateData( TRUE );


	if( (nErrCode = i8094_velocity_move( m_CurSlotNo, wTarget_Axis, m_dwStartSpeed, m_dwDriveSpeed, m_dwAcce, MOVE_DIRECTION_FORWARD )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_velocity_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	else
	{
		m_btMove.EnableWindow( FALSE );
		m_btStop.EnableWindow( TRUE );
	}	
}

void CVelocity_MoveDlg::OnCounterClear()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, wTarget_Axis, 0x00 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_set_cmdcounter() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}	

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, wTarget_Axis, 0x00 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_set_position() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}	
}

void CVelocity_MoveDlg::OnMotionStop()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	UpdateData( TRUE );


	if( (nErrCode = i8094_stop_move( m_CurSlotNo, wTarget_Axis, STOP_SLOWDOWN/*STOP_SUDDEN*/ )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_stop_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	else
	{
		m_btMove.EnableWindow( TRUE );
		m_btStop.EnableWindow( FALSE );
	}
}
